The HDMI firewall programmer copies EDID information onto the [HDMI firewall](https://git.cuvoodoo.info/kingkevin/board/src/branch/hdmi_firewall).

<img src="picture/prog_v0_front.webp" title="front" height="250"/>
<img src="picture/prog_v0_back.webp" title="back" height="250"/>

purpose
=======

To work properly, the [HDMI firewall](https://git.cuvoodoo.info/kingkevin/board/src/branch/hdmi_firewall) needs a copy of the EDID information from the monitor to be protected.
The [installation instructions](https://git.cuvoodoo.info/kingkevin/board/src/branch/hdmi_firewall/README.md) provide a lengthy guide, but requires to be somewhat familiar with using Linux command line tools.
The HDMI firewall programmer is a device that takes care of this process.
You don't even need a computer or any software.

usage
=====

To read the EDID from the monitor to protect:

1. Plug in a cable in the micro-USB port of the HDMI firewall programmer to power it. You can use a USB power bank, since it only requires power and no data transfer (note that some power banks will switch off after some times because the HDMI firewall programmer only draws little power).
2. The EDID LED will stay on if EDID is already present in the embedded memory, else it will blink.
3. The RUN LED should be off.
4. Plug the programmer in the monitor to protect: either using use the HDMI plug directly, or using the HDMI receptacle and an HDMI cable. Ensure only the monitor is connected to the programmer.
5. Press the R/W button for a short time (< 3 seconds).
6. The programmer will try to read the EDID from the monitor and save it in the embedded memory.
7. The RUN LED will stay on if the operation was successful, else it will blink.
8. If the read operation failed, you can retry. If it never succeeds, there might be and error with the cable, connection, or the programmer (but this is unlikely as it has been tested once).

Note: if there already was an EDID in the embedded memory, and the read operation failed, the existing EDID is kept.
If you wish to remove the EDID in the embedded memory, press the R/W button while powering the programmer.
The EDID LED should blink to confirm no EDID is present in the embedded memory.

To write the EDID to the HDMI firewall:

1. Plug in a cable in the micro-USB port of the HDMI firewall programmer to power it. You can use a USB power bank, since it only requires power and no data transfer (note that some power banks will switch off after some times because the HDMI firewall programmer only draws little power).
2. The EDID LED should stay on to confirm an EDID is present in the embedded memory, else read an EDID as described above.
3. The RUN LED should be off.
4. Plug the programmer in the HDMI firewall to program: either using use the HDMI plug directly, or using the HDMI receptacle and an HDMI cable. Ensure only the HDMI firewall is connected to the programmer.
5. Ensure Write Protect (WP) is not enabled on the HDMI firewall (e.g. the tab of the dongle HDMI firewall is not broken or the WP pads are shorted).
6. Press and hold the R/W button for at least 3 seconds.
7. The programmer will try to write the EDID stored in the embedded memory onto the HDMI firewall.
8. The RUN LED will stay on if the operation was successful, else it will blink.
9. If the read operation failed, you can retry. If it never succeeds, there might be and error with the cable, connection, the HDMI firewall is read protected, or the programmer (but this is unlikely as it has been tested once)

Note: the programmer adds the '|' character at the end of the Display Product Name encoded in the EDID.
This allows identifying that the device is connected to the HDMI firewall instead of the actual monitor.

code
====

The source code for the micro-controller of the HDMI firewall programmer is available [here](https://git.cuvoodoo.info/kingkevin/stm8s/src/branch/hdmi_firewall_programmer).
